// Copyright Epic Games, Inc. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleManager.h"
#include "PeelWirelessThread.h"
#include "Containers/Array.h"
#include "ISequencerModule.h"
#include "EditorUtilitySubsystem.h"
#include "EditorUtilityWidgetBlueprint.h"



class UPeelWireless;
class FToolBarBuilder;
class FMenuBuilder;

class FPeelVCamModule : public IModuleInterface
{
public:

	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	/** This function will be bound to Command. */
	void PluginButtonClicked();

	void OnSequencerCreated(TSharedRef < ISequencer>);

	void Register(UPeelWireless*);
	void Remove(UPeelWireless*);

	UPeelWirelessThread* PeelWireless;	

	FDelegateHandle OnSequencerCreatedHandle;

	int test;

private:

	void RegisterMenus();


private:
	TSharedPtr<class FUICommandList> PluginCommands;

	//TSharedPtr < ISequencer> SequencerRef;
};
