// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "LevelSequenceEditorBlueprintLibrary.h"
#include "MovieScene.h"
#include "Sections/MovieScene3DTransformSection.h"
#include "Sections/MovieSceneFloatSection.h"
#include "PeelVCamFunctionLibrary.generated.h"

/**
 * 
 */
UCLASS()
class PEELVCAM_API UPeelVCamFunctionLibrary : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

public:
    // Function to add two integers
    UFUNCTION(BlueprintCallable, Category = "Math|Integer")
        static void Refresh(ULevelSequence* TargetSequence);
    
    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static FFrameTime GetCurrentFrameTime(ULevelSequence* Sequence);

    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static void UpdateOrAddKeysToTransformChannels(UMovieScene3DTransformSection* TransformSection, const FTransform& Transform, FFrameTime CurrentFrameTime);

    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static void UpdateOrAddKeysToFloatChannels(UMovieSceneFloatSection* FloatSection, bool LensKey, bool FocusKey, float Lens, float FocusDistance, FFrameTime CurrentFrameTime);

    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static void DeleteAllKeysInTransformSection(UMovieScene3DTransformSection* TransformSection);

    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static void DeleteActorSectionsInSequence(ULevelSequence* LevelSequence, FGuid TargetActorGuid);
    
    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static FGuid FindActorBindingInSequence(FGuid TargetActorGuid, ULevelSequence* LevelSequence);
    
    UFUNCTION(BlueprintCallable, Category = "Sequence")
        static void FindAdjacentTransformKeyframes(UMovieScene3DTransformSection* TransformSection, int32 CurrFrame, int32& OutPreviousKeyFrame, int32& OutNextKeyFrame);
};

